%define ALD_Ver		2.0

%define OrgName rpm
%define mC_Version 1.2.4s

Name:         mC-%{OrgName}
License:      GPL
Summary:      The RPM package management system.
Version:      4.11.3
Release:      %{mC_Version}.0

#https://ftp.osuosl.org/pub/rpm/releases/rpm-4.11.x/

Source: %{OrgName}-%{version}.tar.xz
Source2: %{name}-%{version}.1-patches.tgz

%define DestDir /Embedded/mC/%{mC_Version}
%define _prefix /usr/mC/%{mC_Version}
%define _bindir /usr/bin
%define _datadir /usr/share
# -----------------------------------------------------
%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}/mC/%{mC_Version}
%define _CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%endif

# -----------------------------------------------------

%if %{have_auto_local}
%define __os_install_post %{nil}
%endif

%if %{_CROSS}
%define CrossPath /cross/%{_target_cpu}
%else
%define CrossPath %{nil}
%endif

#------------------ CROSS DIR --------------------

%define target %{_arch}-linux-musl
%define docdir %{_defaultdocdir}/%{OrgName}

# ------------------- description ------------------------------------
%description
The RPM Package Manager (RPM) is a powerful command line driven
package management system capable of installing, uninstalling,
verifying, querying, and updating software packages. Each software
package consists of an archive of files along with information about
the package like its version, a description, etc.
#-------------------------------
%package tools
Summary:      The RPM package tools rpmspec,rpmgraph,rpm2cpio
%description tools
The RPM package tools
#-------------------------------
%package build
Summary:      The RPM package build tools
%description build
The RPM package build tools
#-------------------------------
%package platform
Summary:      The RPM package all platform files
%description platform
The RPM package all platform files

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{OrgName}-%{version}

tar -xaf %SOURCE2
patch -p0<patches/uC-rpm-4.11.3.patch
patch -p0<patches/rpm-4.15.patch

rm scripts/perl.prov
rm scripts/perl.req
cp -a patches/perl.prov-4.15.1 scripts/perl.prov
cp -a patches/perl.req-4.15.1 scripts/perl.req
cp -a patches/expression.c rpmio/


sed -i s:"@host_alias@":: macros.in

%if %{_target_cpu} == "i386"
sed -i s:"@host_cpu@":"i386": macros.in
sed -i s:"@host@":"i386-pc-linux-gnu": macros.in
%endif

%if %{_target_cpu} == "x86_64"
sed -i s:"@host_cpu@":"x86_64": macros.in
sed -i s:"@host@":"x86_64-pc-linux-gnu": macros.in
sed -i s:"i386 -O2":"i386 -m32 -O2": rpmrc.in
sed -i s:"i486 -O2":"i486 -m32 -O2": rpmrc.in
sed -i s:"i586 -O2":"i586 -m32 -O2": rpmrc.in
sed -i s:"i686 -O2":"i686 -m32 -O2": rpmrc.in
%endif

%if %{_target_cpu} == "x86_x32"
sed -i s:"@host_cpu@":"x86_x32": macros.in
sed -i s:"@host@":"x86_x32-pc-linux-gnu": macros.in
sed -i s:"i386 -O2":"i386 -mx32 -O2": rpmrc.in
sed -i s:"i486 -O2":"i486 -mx32 -O2": rpmrc.in
sed -i s:"i586 -O2":"i586 -mx32 -O2": rpmrc.in
sed -i s:"i686 -O2":"i686 -mx32 -O2": rpmrc.in
%endif

# ------------------- Build ------------------------------------------
%Build
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os -fno-tree-loop-optimize -fno-tree-dominator-opts -fno-strength-reduce"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables -ffunction-sections -fdata-sections -fno-stack-protector"
export CFLAGS="$OPTFLAGS -std=gnu99 -D_LARGEFILE64_SOURCE"
export LDFLAGS="-Wl,--gc-sections"
export CC="%{target}-gcc"

export INSTALL_DATA="/usr/bin/install -p -m 644"
export INSTALL_SCRIPT="/usr/bin/install -p -c"

./configure \
%if %{_CROSS}
	--build=%{_build} \
	--host=%{target} \
%endif
	--exec-prefix=/usr \
	--prefix=/usr \
	--libdir=%{_libdir} \
	--includedir=%{_includedir} \
        --localstatedir=%{_localstatedir} \
	--enable-static \
	--disable-shared \
	--disable-libtool-lock \
	--disable-nls \
	--disable-python \
	--disable-plugins \
	--without-pic \
	--with-beecrypt \
	--with-external-db \
	--without-libiconv-prefix \
	--without-libintl-prefix \
	--without-lua \
	--without-dmalloc \
	&>FConfigure_log.txt

#make -j2 &>FMake_log.txt
make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>Finstall_log.txt

rm -r $RPM_BUILD_ROOT/%{_includedir}
rm $RPM_BUILD_ROOT/%{_libdir}/*.la
rm $RPM_BUILD_ROOT/%{_libdir}/*.a
rm -r $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
#rm $RPM_BUILD_ROOT/%{_libdir}/rpm/rpmdeps
rm -r $RPM_BUILD_ROOT/%{_mandir}/fr
rm -r $RPM_BUILD_ROOT/%{_mandir}/ja
rm -r $RPM_BUILD_ROOT/%{_mandir}/ko
rm -r $RPM_BUILD_ROOT/%{_mandir}/pl
rm -r $RPM_BUILD_ROOT/%{_mandir}/ru
rm -r $RPM_BUILD_ROOT/%{_mandir}/sk

cp -a COPYING CREDITS GROUPS README doc/manual/* $RPM_BUILD_ROOT%{docdir}/
cp -a patches/check-files-dup $RPM_BUILD_ROOT/usr/lib/rpm/check-files-dup

#  have never been used.
rm $RPM_BUILD_ROOT/usr/lib/rpm/osgideps.pl
rm $RPM_BUILD_ROOT/usr/lib/rpm/perldeps.pl

ln -s /bin/rpm $RPM_BUILD_ROOT/usr/lib/rpm/elfdeps
ln -s /bin/rpm $RPM_BUILD_ROOT/usr/lib/rpm/rpmdeps

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-target_platform=%{target}-
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean
%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
/bin
%{_bindir}/rpmverify
%{_bindir}/rpmquery
/usr/lib/rpm/elfdeps
/usr/lib/rpm/macros
/usr/lib/rpm/rpm.supp
/usr/lib/rpm/rpmpopt-*
/usr/lib/rpm/rpmrc
%{_mandir}/man8/rpmsign.8.gz
%{_mandir}/man8/rpmkeys.8.gz
%{_mandir}/man8/rpmdb.8.gz
%{_mandir}/man8/rpm.8.gz

%{docdir}
#{_localstatedir}

%files tools
%{_bindir}/rpmspec
%{_bindir}/rpmgraph
%{_bindir}/rpm2cpio
/usr/lib/rpm/rpm2cpio.sh
/usr/lib/rpm/rpmdb_loadcvt
/usr/lib/rpm/rpmdeps
%{_mandir}/man8/rpmspec.8.gz
%{_mandir}/man8/rpmgraph.8.gz
%{_mandir}/man8/rpmdeps.8.gz
%{_mandir}/man8/rpm2cpio.8.gz

%files build
%{_bindir}/gendiff
%{_mandir}/man1/gendiff.1.gz
%{_mandir}/man8/rpmbuild.8.gz
/usr/lib/rpm/appdata.prov
/usr/lib/rpm/fileattrs
/usr/lib/rpm/brp-*
/usr/lib/rpm/check-*
/usr/lib/rpm/config.*
/usr/lib/rpm/desktop-file.prov
/usr/lib/rpm/find-*
/usr/lib/rpm/fontconfig.prov
/usr/lib/rpm/libtooldeps.sh
/usr/lib/rpm/macros.*
/usr/lib/rpm/mkinstalldirs
/usr/lib/rpm/mono-find-*
/usr/lib/rpm/ocaml-find-*
/usr/lib/rpm/perl.*
/usr/lib/rpm/pkgconfigdeps.sh
/usr/lib/rpm/pythondeps.sh
/usr/lib/rpm/rpm.daily
/usr/lib/rpm/rpm.log
/usr/lib/rpm/script.req
/usr/lib/rpm/tcl.req
/usr/lib/rpm/tgpg
%if %{_arch} == "arm"
/usr/lib/rpm/platform/aarch64-linux
/usr/lib/rpm/platform/armv3l-linux
/usr/lib/rpm/platform/armv4b-linux
/usr/lib/rpm/platform/armv4l-linux
/usr/lib/rpm/platform/armv5tejl-linux
/usr/lib/rpm/platform/armv5tel-linux
/usr/lib/rpm/platform/armv6l-linux
/usr/lib/rpm/platform/armv7hl-linux
/usr/lib/rpm/platform/armv7hnl-linux
/usr/lib/rpm/platform/armv7l-linux
/usr/lib/rpm/platform/armv8hl-linux
/usr/lib/rpm/platform/armv8l-linux
%else
/usr/lib/rpm/platform/aarch64-linux
/usr/lib/rpm/platform/armv5tl-linux
/usr/lib/rpm/platform/armv5tel-linux
/usr/lib/rpm/platform/armv6hl-linux
/usr/lib/rpm/platform/armv6l-linux
/usr/lib/rpm/platform/armv7hl-linux
/usr/lib/rpm/platform/armv7hnl-linux
/usr/lib/rpm/platform/armv7l-linux
/usr/lib/rpm/platform/armv8hl-linux
/usr/lib/rpm/platform/armv8l-linux
/usr/lib/rpm/platform/amd64-linux
/usr/lib/rpm/platform/athlon-linux
/usr/lib/rpm/platform/geode-linux
/usr/lib/rpm/platform/i386-linux
/usr/lib/rpm/platform/i486-linux
/usr/lib/rpm/platform/i586-linux
/usr/lib/rpm/platform/i686-linux
/usr/lib/rpm/platform/pentium3-linux
/usr/lib/rpm/platform/pentium4-linux
/usr/lib/rpm/platform/x86_64-linux
/usr/lib/rpm/platform/x86_x32-linux
/usr/lib/rpm/platform/win32-linux
/usr/lib/rpm/platform/win64-linux
%endif
/usr/lib/rpm/platform/noarch-linux

%files platform
%if %{_arch} == "arm"
/usr/lib/rpm/platform/amd64-linux
/usr/lib/rpm/platform/athlon-linux
/usr/lib/rpm/platform/geode-linux
/usr/lib/rpm/platform/i386-linux
/usr/lib/rpm/platform/i486-linux
/usr/lib/rpm/platform/i586-linux
/usr/lib/rpm/platform/i686-linux
/usr/lib/rpm/platform/x86_64-linux
/usr/lib/rpm/platform/x86_x32-linux
/usr/lib/rpm/platform/win32-linux
/usr/lib/rpm/platform/win64-linux
/usr/lib/rpm/platform/pentium3-linux
/usr/lib/rpm/platform/pentium4-linux
%else
/usr/lib/rpm/platform/armv3l-linux
/usr/lib/rpm/platform/armv4b-linux
/usr/lib/rpm/platform/armv4l-linux
/usr/lib/rpm/platform/armv5tejl-linux
%endif
/usr/lib/rpm/platform/alpha-linux
/usr/lib/rpm/platform/alphaev5-linux
/usr/lib/rpm/platform/alphaev56-linux
/usr/lib/rpm/platform/alphaev6-linux
/usr/lib/rpm/platform/alphaev67-linux
/usr/lib/rpm/platform/alphapca56-linux
/usr/lib/rpm/platform/ia32e-linux
/usr/lib/rpm/platform/ia64-linux
/usr/lib/rpm/platform/m68k-linux
/usr/lib/rpm/platform/ppc-linux
/usr/lib/rpm/platform/ppc32dy4-linux
/usr/lib/rpm/platform/ppc64-linux
/usr/lib/rpm/platform/ppc64iseries-linux
/usr/lib/rpm/platform/ppc64le-linux
/usr/lib/rpm/platform/ppc64p7-linux
/usr/lib/rpm/platform/ppc64pseries-linux
/usr/lib/rpm/platform/ppc8260-linux
/usr/lib/rpm/platform/ppc8560-linux
/usr/lib/rpm/platform/ppciseries-linux
/usr/lib/rpm/platform/ppcpseries-linux
/usr/lib/rpm/platform/s390-linux
/usr/lib/rpm/platform/s390x-linux
/usr/lib/rpm/platform/sh-linux
/usr/lib/rpm/platform/sh3-linux
/usr/lib/rpm/platform/sh4-linux
/usr/lib/rpm/platform/sh4a-linux
/usr/lib/rpm/platform/sparc-linux
/usr/lib/rpm/platform/sparc64-linux
/usr/lib/rpm/platform/sparc64v-linux
/usr/lib/rpm/platform/sparcv8-linux
/usr/lib/rpm/platform/sparcv9-linux
/usr/lib/rpm/platform/sparcv9v-linux
